"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const controls_1 = require("@jupyter-widgets/controls");
const version_1 = require("./version");
class ButtonSingletonModel extends controls_1.ButtonModel {
    defaults() {
        return Object.assign({}, super.defaults(), { _model_name: 'ButtonSingletonModel', _model_module: version_1.MODULE_NAME, _model_module_version: version_1.MODULE_VERSION, _view_name: 'ButtonSingletonView', _view_module: version_1.MODULE_NAME, _view_module_version: version_1.MODULE_VERSION, _focus: null, _tooltip: null, tabindex: null });
    }
}
exports.ButtonSingletonModel = ButtonSingletonModel;
class ComboboxSingletonModel extends controls_1.ComboboxModel {
    defaults() {
        return Object.assign({}, super.defaults(), { _model_name: 'ComboboxSingletonModel', _model_module: version_1.MODULE_NAME, _model_module_version: version_1.MODULE_VERSION, _view_name: 'ComboboxSingletonView', _view_module: version_1.MODULE_NAME, _view_module_version: version_1.MODULE_VERSION, _focus: null, _tooltip: null, tabindex: null });
    }
}
exports.ComboboxSingletonModel = ComboboxSingletonModel;
class DropdownSingletonModel extends controls_1.DropdownModel {
    defaults() {
        return Object.assign({}, super.defaults(), { _model_name: 'DropdownSingletonModel', _model_module: version_1.MODULE_NAME, _model_module_version: version_1.MODULE_VERSION, _view_name: 'DropdownSingletonView', _view_module: version_1.MODULE_NAME, _view_module_version: version_1.MODULE_VERSION, _focus: null, _tooltip: null, tabindex: null });
    }
}
exports.DropdownSingletonModel = DropdownSingletonModel;
class HTMLSingletonModel extends controls_1.HTMLModel {
    defaults() {
        return Object.assign({}, super.defaults(), { _model_name: 'HTMLSingletonModel', _model_module: version_1.MODULE_NAME, _model_module_version: version_1.MODULE_VERSION, _view_name: 'HTMLSingletonView', _view_module: version_1.MODULE_NAME, _view_module_version: version_1.MODULE_VERSION, _focus: null, _tooltip: null, tabindex: null });
    }
}
exports.HTMLSingletonModel = HTMLSingletonModel;
class HTMLMathSingletonModel extends controls_1.HTMLMathModel {
    defaults() {
        return Object.assign({}, super.defaults(), { _model_name: 'HTMLMathSingletonModel', _model_module: version_1.MODULE_NAME, _model_module_version: version_1.MODULE_VERSION, _view_name: 'HTMLMathSingletonView', _view_module: version_1.MODULE_NAME, _view_module_version: version_1.MODULE_VERSION, _focus: null, _tooltip: null, tabindex: null });
    }
}
exports.HTMLMathSingletonModel = HTMLMathSingletonModel;
class TextSingletonModel extends controls_1.TextModel {
    defaults() {
        return Object.assign({}, super.defaults(), { _model_name: 'TextSingletonModel', _model_module: version_1.MODULE_NAME, _model_module_version: version_1.MODULE_VERSION, _view_name: 'TextSingletonView', _view_module: version_1.MODULE_NAME, _view_module_version: version_1.MODULE_VERSION, _focus: null, _tooltip: null, tabindex: null });
    }
}
exports.TextSingletonModel = TextSingletonModel;
class TextareaSingletonModel extends controls_1.TextareaModel {
    defaults() {
        return Object.assign({}, super.defaults(), { _model_name: 'TextareaSingletonModel', _model_module: version_1.MODULE_NAME, _model_module_version: version_1.MODULE_VERSION, _view_name: 'TextareaSingletonView', _view_module: version_1.MODULE_NAME, _view_module_version: version_1.MODULE_VERSION, _focus: null, _tooltip: null, tabindex: null });
    }
}
exports.TextareaSingletonModel = TextareaSingletonModel;
class ToggleButtonSingletonModel extends controls_1.ToggleButtonModel {
    defaults() {
        return Object.assign({}, super.defaults(), { _model_name: 'ToggleButtonSingletonModel', _model_module: version_1.MODULE_NAME, _model_module_version: version_1.MODULE_VERSION, _view_name: 'ToggleButtonSingletonView', _view_module: version_1.MODULE_NAME, _view_module_version: version_1.MODULE_VERSION, _focus: null, _tooltip: null, tabindex: null });
    }
}
exports.ToggleButtonSingletonModel = ToggleButtonSingletonModel;
class ButtonSingletonView extends controls_1.ButtonView {
    render() {
        super.render();
        this.update_tabindex();
        this.update_tooltip();
        this.update_title();
        this.update_focus();
        this.model.on('change:tabindex', this.update_tabindex, this);
        this.model.on('change:_tooltip', this.update_title, this);
        this.model.on('change:tooltip', this.update_tooltip, this);
        this.model.on('change:_focus', this.update_focus, this);
    }
    update_tabindex() {
        let tabindex = this.model.get('tabindex');
        if (tabindex)
            this.el.setAttribute('tabindex', tabindex);
        else
            this.el.removeAttribute('tabindex');
    }
    update_tooltip() {
        if (this.model.get('tooltip'))
            this.model.set('_tooltip', this.model.get('tooltip'));
    }
    update_title() {
        let title = this.model.get('_tooltip');
        if (title)
            this.el.setAttribute('title', title);
        else
            this.el.removeAttribute('title');
    }
    update_focus() {
        let focus = this.model.get('_focus');
        if (!focus)
            return;
        if (focus == 'on') {
            this.el.focus();
        }
        else if (focus == 'off') {
            this.el.blur();
        }
    }
}
exports.ButtonSingletonView = ButtonSingletonView;
;
class ComboboxSingletonView extends controls_1.ComboboxView {
    render() {
        super.render();
        this.update_tabindex();
        this.update_tooltip();
        this.update_title();
        this.update_focus();
        this.model.on('change:tabindex', this.update_tabindex, this);
        this.model.on('change:_tooltip', this.update_title, this);
        this.model.on('change:description_tooltip', this.update_tooltip, this);
        this.model.on('change:_focus', this.update_focus, this);
    }
    update_tabindex() {
        let tabindex = this.model.get('tabindex');
        if (tabindex)
            this.textbox.setAttribute('tabindex', tabindex);
        else
            this.textbox.removeAttribute('tabindex');
    }
    update_tooltip() {
        if (this.model.get('description_tooltip')) {
            this.model.set('_tooltip', this.model.get('description_tooltip'));
        }
    }
    update_title() {
        let title = this.model.get('_tooltip');
        if (title)
            this.textbox.setAttribute('title', title);
        else
            this.textbox.removeAttribute('title');
    }
    update_focus() {
        let focus = this.model.get('_focus');
        if (!focus)
            return;
        if (focus == 'on') {
            this.textbox.focus();
        }
        else if (focus == 'off') {
            this.textbox.blur();
        }
    }
}
exports.ComboboxSingletonView = ComboboxSingletonView;
;
class DropdownSingletonView extends controls_1.DropdownView {
    render() {
        super.render();
        this.update_tabindex();
        this.update_tooltip();
        this.update_title();
        this.update_focus();
        this.model.on('change:tabindex', this.update_tabindex, this);
        this.model.on('change:_tooltip', this.update_title, this);
        this.model.on('change:description_tooltip', this.update_tooltip, this);
        this.model.on('change:_focus', this.update_focus, this);
    }
    update_tabindex() {
        let tabindex = this.model.get('tabindex');
        if (tabindex)
            this.listbox.setAttribute('tabindex', tabindex);
        else
            this.listbox.removeAttribute('tabindex');
    }
    update_tooltip() {
        if (this.model.get('description_tooltip')) {
            this.model.set('_tooltip', this.model.get('description_tooltip'));
        }
    }
    update_title() {
        var title = this.model.get('description_tooltip');
        if (!title)
            this.listbox.removeAttribute('title');
        else
            this.listbox.setAttribute('title', title);
    }
    update_focus() {
        let focus = this.model.get('_focus');
        if (!focus)
            return;
        if (focus == 'on') {
            this.listbox.focus();
        }
        else if (focus == 'off') {
            this.listbox.blur();
        }
    }
}
exports.DropdownSingletonView = DropdownSingletonView;
;
class HTMLSingletonView extends controls_1.HTMLView {
    render() {
        super.render();
        this.update_tabindex();
        this.update_tooltip();
        this.update_title();
        this.update_focus();
        this.model.on('change:tabindex', this.update_tabindex, this);
        this.model.on('change:_tooltip', this.update_title, this);
        this.model.on('change:description_tooltip', this.update_tooltip, this);
        this.model.on('change:_focus', this.update_focus, this);
    }
    update_tabindex() {
        let tabindex = this.model.get('tabindex');
        if (tabindex)
            this.content.setAttribute('tabindex', tabindex);
        else
            this.content.removeAttribute('tabindex');
    }
    update_tooltip() {
        if (this.model.get('description_tooltip')) {
            this.model.set('_tooltip', this.model.get('description_tooltip'));
        }
    }
    update_title() {
        let title = this.model.get('_tooltip');
        if (title)
            this.content.setAttribute('title', title);
        else
            this.content.removeAttribute('title');
    }
    update_focus() {
        let focus = this.model.get('_focus');
        if (!focus)
            return;
        if (focus == 'on') {
            this.content.focus();
        }
        else if (focus == 'off') {
            this.content.blur();
        }
    }
}
exports.HTMLSingletonView = HTMLSingletonView;
;
class HTMLMathSingletonView extends HTMLSingletonView {
    render() {
        super.render();
    }
}
exports.HTMLMathSingletonView = HTMLMathSingletonView;
;
class TextSingletonView extends controls_1.TextView {
    render() {
        super.render();
        this.update_tabindex();
        this.update_tooltip();
        this.update_title();
        this.update_focus();
        this.model.on('change:tabindex', this.update_tabindex, this);
        this.model.on('change:_tooltip', this.update_title, this);
        this.model.on('change:description_tooltip', this.update_tooltip, this);
        this.model.on('change:_focus', this.update_focus, this);
    }
    update_tabindex() {
        let tabindex = this.model.get('tabindex');
        if (tabindex)
            this.textbox.setAttribute('tabindex', tabindex);
        else
            this.textbox.removeAttribute('tabindex');
    }
    update_tooltip() {
        if (this.model.get('description_tooltip')) {
            this.model.set('_tooltip', this.model.get('description_tooltip'));
        }
    }
    update_title() {
        let title = this.model.get('_tooltip');
        if (title)
            this.textbox.setAttribute('title', title);
        else
            this.textbox.removeAttribute('title');
    }
    update_focus() {
        let focus = this.model.get('_focus');
        if (!focus)
            return;
        if (focus == 'on') {
            this.textbox.focus();
        }
        else if (focus == 'off') {
            this.textbox.blur();
        }
    }
}
exports.TextSingletonView = TextSingletonView;
;
class TextareaSingletonView extends controls_1.TextareaView {
    render() {
        super.render();
        this.update_tabindex();
        this.update_tooltip();
        this.update_title();
        this.update_focus();
        this.model.on('change:tabindex', this.update_tabindex, this);
        this.model.on('change:_tooltip', this.update_title, this);
        this.model.on('change:description_tooltip', this.update_tooltip, this);
        this.model.on('change:_focus', this.update_focus, this);
    }
    update_tabindex() {
        let tabindex = this.model.get('tabindex');
        if (tabindex)
            this.textbox.setAttribute('tabindex', tabindex);
        else
            this.textbox.removeAttribute('tabindex');
    }
    update_tooltip() {
        if (this.model.get('description_tooltip')) {
            this.model.set('_tooltip', this.model.get('description_tooltip'));
        }
    }
    update_title() {
        let title = this.model.get('_tooltip');
        if (title)
            this.textbox.setAttribute('title', title);
        else
            this.textbox.removeAttribute('title');
    }
    update_focus() {
        let focus = this.model.get('_focus');
        if (!focus)
            return;
        if (focus == 'on') {
            this.textbox.focus();
        }
        else if (focus == 'off') {
            this.textbox.blur();
        }
    }
}
exports.TextareaSingletonView = TextareaSingletonView;
;
class ToggleButtonSingletonView extends controls_1.ToggleButtonView {
    render() {
        super.render();
        this.update_tabindex();
        this.update_tooltip();
        this.update_title();
        this.update_focus();
        this.model.on('change:tabindex', this.update_tabindex, this);
        this.model.on('change:_tooltip', this.update_title, this);
        this.model.on('change:tooltip', this.update_tooltip, this);
        this.model.on('change:description_tooltip', this.update_tooltip, this);
        this.model.on('change:_focus', this.update_focus, this);
    }
    update_tabindex() {
        let tabindex = this.model.get('tabindex');
        if (tabindex)
            this.el.setAttribute('tabindex', tabindex);
        else
            this.el.removeAttribute('tabindex');
    }
    update_tooltip() {
        if (this.model.get('tooltip')) {
            this.model.set('_tooltip', this.model.get('tooltip'));
        }
        else if (this.model.get('description_tooltip')) {
            this.model.set('_tooltip', this.model.get('description_tooltip'));
        }
    }
    update_title() {
        let title = this.model.get('_tooltip');
        if (title)
            this.el.setAttribute('title', title);
        else
            this.el.removeAttribute('title');
    }
    update_focus() {
        let focus = this.model.get('_focus');
        if (!focus)
            return;
        if (focus == 'on') {
            this.el.focus();
        }
        else if (focus == 'off') {
            this.el.blur();
        }
    }
}
exports.ToggleButtonSingletonView = ToggleButtonSingletonView;
;
//# sourceMappingURL=singleton_widgets.js.map